Device 16F873A	 
Xtal 4	 

'------------------------------------- -------------------------------------
Declare Adin_Res 10         ' P    = 10
Declare Adin_Tad FRC        '    = FRC 
Declare Adin_Stime 50       '     50    

'-------------------------------  --------------------------------
Declare LCD_Type ALPHA      '   -  - 
Declare LCD_DTPin PORTB.4 	'    
Declare LCD_ENPin PORTB.3 	'   E
Declare LCD_RSPin PORTB.2 	'   RS 
Declare LCD_Interface 4 	'   
Declare LCD_CommandUs 2000	'     
Declare LCD_DataUs 50 	    '    
Declare LCD_Lines 2 	    '    

'------------------------------------ ------------------------------------
'Declare PortB_Pullups = OFF '     PORTB 
Declare All_Digital = OFF 	'        
ADCON1 = %10000000 	  	    '    PORTA   
TRISA = %00000011 	  	    '   () AN0,AN1 (PORTA.0 ,PORTA.1) 
TRISC = %01011011  	  	    '
TRISB = %00000000
PORTB = %00000010
PORTC = %00000000

'-------------------------- OPTION_REG ----------------------------------------
Symbol PS0 = OPTION_REG.0	                       '    TMR0 
Symbol PS1 = OPTION_REG.1	                       '    TMR0 
Symbol PS2 = OPTION_REG.2	                       '    TMR0 
Symbol PSA = OPTION_REG.3	                       '    
Symbol T0SE = OPTION_REG.4	                       '    TMR0     
Symbol T0CS = OPTION_REG.5	                       '     TMR0 
Symbol INTEDG = OPTION_REG.6	                   '         INT 
Symbol NOT_RBPU = OPTION_REG.7	                   '     PORTB 
                                                               
'-------------------------- INTCON --------------------------------------------
Symbol RBIF = INTCON.0                             '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1                             '     PORTB.0(INT)                                                                   
Symbol T0IF = INTCON.2                             '   TMR0 
Symbol RBIE = INTCON.3                             '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4                             '     PORTB.0(INT)
Symbol T0IE = INTCON.5                             '      TMR0
Symbol PEIE = INTCON.6                             '      
Symbol GIE  = INTCON.7                             '    

'--------------------------------- ----------------------------------
Dim VAR1    As Float    	                       '    V
Dim VAR2    As Float   	                           '    I
Dim J       As Float      	                       '   U
Dim K       As Float      	                       '   I 
Dim V       As Float      	                       ' 
Dim A       As Float      	                       ' 
Dim B       As Float      	                       '  10%    (0.1)
Dim PWMout  As Word  	                           ' 
Dim L       As Byte       	                       '   L  Byte
Dim BIG     As Dword   	                           '    
Dim BIG1    As BIG.HighWord
Dim Hour    As Byte 	                           ' 
Dim Minute  As Byte 	                           ' 
Dim Sec     As Byte 	                           ' 
Dim Stat    As Byte 	                           '  = 1 , 0 =  

Symbol SB1      = PORTC.3  	                       ' 
Symbol SB2      = PORTC.4  	                       ' 
Symbol SB3      = PORTC.0  	                       ' . 
Symbol SB4      = PORTC.1  	                       ' CTOP
Symbol SP       = PORTC.7  	                       ' 
Symbol PS_ON    = PORTC.5  	                       '  
Symbol No_Zar   = PORTB.1  	                       '  
Symbol Zar      = PORTB.0  	                       ' 

'--------------------------  TMR0   --------------------
OPTION_REG = %10000111
TMR0 = $00                                         '   TMR0 
T0IE = 1 
GIE = 1    		                                   '   
BIG = 1108404

On_Interrupt GoTo  Int_Label 

J = 50.6        	                               '   U
K = 51.1        	                               '   I 
Hour = 0        
Minute = 0 
Sec = 0
' ----------------------------------------------- init -----------------------------------------------
init:
PWMout = 0	                                       ' 
Cls
Print At 1, 1, "AVTO ACCU CHARGE"                  '  
Print At 2, 1, "WWW.PICBASIC.RU"                   '  
DelayMS 2000                                       '   2 
Cls                                                '  
Print At 1, 1, "Charge MAX 80 Ah"                  '
Print At 2, 1, "Charge TIME 12 H"                  '
DelayMS 2000                                       '
Cls                                                '
Print At 1, 1, "Soft V1.1 120311"                     '
Print At 2, 1, "   Andriy  S  "                    '
DelayMS 2000 
Sec = 0                                            '  
Cls                                                '
'-------------------------------- ---------------------------------------

MainProgram:

VAR1 = ADIn 0		                               '    0-       VAR1
DelayUS 1		                                   '  1 

VAR2 = ADIn 1		                               '    1-       VAR2
DelayUS 1       	                               '  1 

V = VAR1 / J 		                               '  U  20
A = VAR2 / K 		                               '  I  20  

If SB1 = 0 Then                                    '   5 Ah
    DelayMS 100 
    L = L + 5 
    High SP
    DelayMS 100 
    Low  SP  
EndIf
                                 
If L >= 80 Then L = 80                             '  L >= 80   

If SB2 = 0 Then                                    '   5 Ah
    DelayMS 100 
    L = L - 5 
    High SP
    DelayMS 100 
    Low  SP
EndIf

If L < 0 Then L = 0	                               '  L <= 0   
                                                   
If V > 9 And SB3 = 0 And L > 0 Then                ' 
    DelayMS 100 
    High PS_ON
    High SP
    DelayMS 100 
    Low  SP
    High Zar
    Low No_Zar
    B = L / 10   		                           '   10      
    Stat = 1
EndIf

GoSub lcd

If Stat = 0 Then 
    Sec = 0 
    Minute = 0
    Hour = 0                                       '  
    GoTo MainProgram
Else
    GoTo Loop
EndIf

Loop:

If V > 15  And A > 0 Then Dec PWMout		        '    15   


If A < B Then                                       '      
    Inc PWMout 
ElseIf A > B Then 
    Dec PWMout 
Else 
    A = B  
EndIf  

If V < 9 Then                                       '        
    PWMout = 0 
    Low PS_ON
    L = 0 
    High No_Zar 
    Stat = 0
EndIf

If V > 18 Then                                      '  18 
    DelayMS 1000 
    PWMout = 0 
    Low PS_ON
    Low Zar
    High No_Zar
    L = 0
    Stat = 0
EndIf

If A > 14 Then                                      '    14     
    PWMout = 0                                      ' ??????????????????????????????????????????????????????????????
    Low PS_ON
    Low Zar
    High No_Zar
    L = 0
    Stat = 0
EndIf 

If SB4 = 0 Then                                     '    - SB4
    PWMout = 0 
    Low PS_ON 
    Low Zar
    High No_Zar
    L = 0 
    High SP
    DelayMS 100 
    Low SP
    Stat = 0
EndIf

If Sec = 60 Then                                    '  60 ,    ,   
    Sec = 0 
    Inc Minute
EndIf

If Minute = 60 Then                                 '  60 ,    0,   
    Minute = 0 
    Inc Hour 
EndIf

If Hour = 12 Then  
    PWMout = 0 
    Low PS_ON 
    Low Zar
    High No_Zar
    L = 0
    Stat = 0
EndIf

If PWMout <= 0 Then 
    PWMout = 0 
ElseIf PWMout >= 255 Then PWMout = 255
EndIf

HPWM 1, PWMout, 15000                                                '

GoSub lcd

GoTo MainProgram '      

End

lcd:

Print At 1, 1, "AC" , $3E , Dec2 L, "Ah "                                '      
Print At 1, 9, Dec2 Hour, ":", Dec2 Minute, ":", Dec2 Sec
Print At 2, 1, "U=", Dec1 V, "V "                                   '        VAR1
Print At 2, 10, "I=", Dec1 A, "A  "                                 '        VAR2

Return

'--------------------------  --------------------------
Int_Label: ' 
Context Save                                        '    

If T0IF = 1 Then Dec BIG1	                        '   TMR0,        BIG1, 
                                                    '   ,    65536  BIG,    

If BIG < 0 Then BIG = BIG + 1108404 : Inc Sec       '  BIG < 0    ,     
                                                    '  1000000 
T0IF = 0                                            '    

Context Restore                                     '    

End 
